SoDirectionalLightManip(3)

NAME
SoDirectionalLightManip - The SoDirectionalLightManip class is used to manipulate SoDirectionalLight nodes.

SYNOPSIS

#include <Inventor/manips/SoDirectionalLightManip.h>

Inherits SoDirectionalLight.

  Public Member Functions
virtual SoType getTypeId (void) const
SoDirectionalLightManip (void)
SoDragger * getDragger (void)
SbBool replaceNode (SoPath *path)
SbBool replaceManip (SoPath *path, SoDirectionalLight *newone) const
virtual void doAction (SoAction *action)
virtual void callback (SoCallbackAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
virtual void getMatrix (SoGetMatrixAction *action)
virtual void handleEvent (SoHandleEventAction *action)
virtual void pick (SoPickAction *action)
virtual void search (SoSearchAction *action)
virtual SoChildList * getChildren (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoDirectionalLightManip (void)
void setDragger (SoDragger *newdragger)
virtual void copyContents (const SoFieldContainer *fromfc, SbBool copyconnections)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
static void transferFieldValues (const SoDirectionalLight *from, SoDirectionalLight *to)
static void valueChangedCB (void *f, SoDragger *d)
static void fieldSensorCB (void *f, SoSensor *d)

  Protected Attributes
SoFieldSensor * directionFieldSensor
SoFieldSensor * colorFieldSensor
SoChildList * children

  Additional Inherited Members

Detailed Description

The SoDirectionalLightManip class is used to manipulate SoDirectionalLight nodes. A manipulator is used by replacing the node you want to edit in the graph with the manipulator. Draggers are used to manipulate the node. When manipulation is finished, the node is put back into the graph, replacing the manipulator.

 Example of DirectionalLight Manipulator

Constructor & Destructor Documentation

  SoDirectionalLightManip::SoDirectionalLightManip (void)
The constructor sets up the internal SoDirectionalLightDragger used by the manipulator.

  SoDirectionalLightManip::~SoDirectionalLightManip (void) [protected], [virtual]
Destructor. Clean up resources used by manipulator.

Member Function Documentation

  SoType SoDirectionalLightManip::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoDirectionalLightManip::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoDirectionalLight.

  const SoFieldData ** SoDirectionalLightManip::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoDirectionalLightManip::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoDirectionalLight.

  SoDragger * SoDirectionalLightManip::getDragger (void)
Return pointer to internal SoDirectionalLightDragger dragger.

  SbBool SoDirectionalLightManip::replaceNode (SoPath * path)
Replaces the node specified by path with this manipulator. The manipulator will copy the field data from the node, to make it affect the state in the same way as the node.

  SbBool SoDirectionalLightManip::replaceManip (SoPath * path, SoDirectionalLight * newone) const
Replaces this manipulator from the position specified by path with newnode. If newnode is NULL, an SoDirectionalLight will be created for you.

  void SoDirectionalLightManip::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoDirectionalLightManip::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoLight.

  void SoDirectionalLightManip::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoDirectionalLight.

  void SoDirectionalLightManip::getBoundingBox (SoGetBoundingBoxAction * action) [virtual]
Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoNode.

  void SoDirectionalLightManip::getMatrix (SoGetMatrixAction * action) [virtual]
Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

  void SoDirectionalLightManip::handleEvent (SoHandleEventAction * action) [virtual]
Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also override this method.

Reimplemented from SoNode.

  void SoDirectionalLightManip::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

  void SoDirectionalLightManip::search (SoSearchAction * action) [virtual]
Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction -- if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also
    SoSearchAction

Reimplemented from SoNode.

  SoChildList * SoDirectionalLightManip::getChildren (void) const [virtual]
Returns the children of this node. This node only has the dragger as a child.

Reimplemented from SoNode.

  void SoDirectionalLightManip::setDragger (SoDragger * newdragger) [protected]
Set dragger to be used by this manipulator.

  void SoDirectionalLightManip::copyContents (const SoFieldContainer * from, SbBool copyconnections) [protected], [virtual]
Makes a deep copy of all data of from into this instance, except external scene graph references if copyconnections is FALSE.

This is the method that should be overridden by extension node / engine / dragger / whatever subclasses which need to account for internal data that are not handled automatically.

For copying nodes from application code, you should not invoke this function directly, but rather call the SoNode::copy() function:

SoNode * mynewnode = templatenode->copy();

The same also goes for engines.

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to its parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

void
MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
                                  SbBool copyconnections)
{
  // let parent superclasses do their thing (copy fields, copy
  // instance name, etc.)
  SoNode::copyContents(from, copyconnections);
  // [..then copy internal data..]
}

Reimplemented from SoNode.

  void SoDirectionalLightManip::transferFieldValues (const SoDirectionalLight * from, SoDirectionalLight * to) [static], [protected]
Copies field values.

  void SoDirectionalLightManip::valueChangedCB (void * m, SoDragger * dragger) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Convert from matrix to direction.

  void SoDirectionalLightManip::fieldSensorCB (void * m, SoSensor * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Member Data Documentation

  SoFieldSensor * SoDirectionalLightManip::directionFieldSensor [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  SoFieldSensor * SoDirectionalLightManip::colorFieldSensor [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  SoChildList * SoDirectionalLightManip::children [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Author

Generated automatically by Doxygen for Coin from the source code.